:- cycle(X,Y), not edge(X,Y).

:- node(X), #count{ Y : cycle(X,Y) } != 1.
:- node(Y), #count{ X : cycle(X,Y) } != 1.

reached(X) :- #min{ Y : node(Y) } = X.
reached(Y) :- cycle(X,Y), reached(X).
:- node(Y), not reached(Y).

:~ cycle(X,Y), cost(X,Y,C). [C,X]
